freedombone-sec 50KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991992993994995996997998999100010011002100310041005100610071008100910101011101210131014101510161017101810191020102110221023102410251026102710281029103010311032103310341035103610371038103910401041104210431044104510461047104810491050105110521053105410551056105710581059106010611062106310641065106610671068106910701071107210731074107510761077107810791080108110821083108410851086108710881089109010911092109310941095109610971098109911001101110211031104110511061107110811091110111111121113111411151116111711181119112011211122112311241125112611271128112911301131113211331134113511361137113811391140114111421143114411451146114711481149115011511152115311541155115611571158115911601161116211631164116511661167116811691170117111721173117411751176117711781179118011811182118311841185118611871188118911901191119211931194119511961197119811991200120112021203120412051206120712081209121012111212121312141215121612171218121912201221122212231224122512261227122812291230123112321233123412351236123712381239124012411242124312441245124612471248124912501251125212531254125512561257125812591260126112621263126412651266126712681269127012711272127312741275127612771278127912801281128212831284128512861287128812891290129112921293129412951296129712981299130013011302130313041305130613071308130913101311131213131314131513161317131813191320132113221323132413251326132713281329133013311332133313341335133613371338133913401341134213431344134513461347134813491350135113521353135413551356135713581359136013611362136313641365136613671368136913701371137213731374137513761377137813791380138113821383138413851386138713881389139013911392139313941395139613971398139914001401140214031404140514061407140814091410141114121413141414151416141714181419142014211422142314241425142614271428142914301431143214331434143514361437143814391440144114421443144414451446144714481449145014511452145314541455145614571458145914601461146214631464146514661467146814691470147114721473147414751476147714781479148014811482148314841485148614871488148914901491149214931494149514961497149814991500150115021503150415051506150715081509151015111512151315141515151615171518151915201521152215231524152515261527152815291530153115321533153415351536153715381539154015411542154315441545154615471548154915501551155215531554155515561557155815591560156115621563156415651566156715681569157015711572157315741575157615771578157915801581158215831584158515861587158815891590159115921593159415951596159715981599160016011602160316041605160616071608160916101611161216131614161516161617161816191620
  1. #!/bin/bash
  2. # _____ _ _
  3. # | __|___ ___ ___ _| |___ _____| |_ ___ ___ ___
  4. # | __| _| -_| -_| . | . | | . | . | | -_|
  5. # |__| |_| |___|___|___|___|_|_|_|___|___|_|_|___|
  6. #
  7. # Freedom in the Cloud
  8. #
  9. # Alters the security settings
  10. #
  11. # License
  12. # =======
  13. #
  14. # Copyright (C) 2015-2018 Bob Mottram <bob@freedombone.net>
  15. #
  16. # This program is free software: you can redistribute it and/or modify
  17. # it under the terms of the GNU Affero General Public License as published by
  18. # the Free Software Foundation, either version 3 of the License, or
  19. # (at your option) any later version.
  20. #
  21. # This program is distributed in the hope that it will be useful,
  22. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  23. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  24. # GNU Affero General Public License for more details.
  25. #
  26. # You should have received a copy of the GNU Affero General Public License
  27. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  28. PROJECT_NAME='freedombone'
  29. export TEXTDOMAIN=${PROJECT_NAME}-sec
  30. export TEXTDOMAINDIR="/usr/share/locale"
  31. CONFIGURATION_FILE=$HOME/${PROJECT_NAME}.cfg
  32. COMPLETION_FILE=$HOME/${PROJECT_NAME}-completed.txt
  33. UTILS_FILES="/usr/share/${PROJECT_NAME}/utils/${PROJECT_NAME}-utils-*"
  34. for f in $UTILS_FILES
  35. do
  36. source "$f"
  37. done
  38. SSL_PROTOCOLS=
  39. SSL_CIPHERS=
  40. SSH_CIPHERS=
  41. SSH_MACS=
  42. SSH_KEX=
  43. SSH_HOST_KEY_ALGORITHMS=
  44. SSH_PASSWORDS=
  45. XMPP_CIPHERS=
  46. XMPP_ECC_CURVE=
  47. WEBSITES_DIRECTORY='/etc/nginx/sites-available'
  48. DOVECOT_CIPHERS='/etc/dovecot/conf.d/10-ssl.conf'
  49. SSH_CONFIG='/etc/ssh/sshd_config'
  50. XMPP_CONFIG='/etc/prosody/conf.avail/xmpp.cfg.lua'
  51. MINIMUM_LENGTH=6
  52. IMPORT_FILE=
  53. EXPORT_FILE=
  54. CURRENT_DIR=$(pwd)
  55. DH_KEYLENGTH=2048
  56. LETSENCRYPT_SERVER='https://acme-v01.api.letsencrypt.org/directory'
  57. MY_USERNAME=
  58. function ping_enable_disable {
  59. ping_str=$"\\nDo you want to enable other systems to ping this machine?\\n\\nPing may be useful for diagnostic purposes, but for added security you may not want to enable it."
  60. enable_ping="no"
  61. dialog --title $"Enable Ping / ICMP" \
  62. --backtitle $"Freedombone Control Panel" \
  63. --defaultno \
  64. --yesno "$ping_str" 10 60
  65. sel=$?
  66. case $sel in
  67. 0) enable_ping="yes";;
  68. 255) return;;
  69. esac
  70. if [[ $enable_ping == "yes" ]]; then
  71. iptables -A INPUT -p icmp --icmp-type echo-request -j ACCEPT
  72. iptables -A OUTPUT -p icmp --icmp-type echo-reply -j ACCEPT
  73. echo "0" > /proc/sys/net/ipv4/icmp_echo_ignore_all
  74. else
  75. iptables -D INPUT -p icmp --icmp-type echo-request -j ACCEPT
  76. iptables -D OUTPUT -p icmp --icmp-type echo-reply -j ACCEPT
  77. echo "1" > /proc/sys/net/ipv4/icmp_echo_ignore_all
  78. fi
  79. }
  80. function any_key_verify {
  81. echo ''
  82. read -n1 -rsp $"Press any key to continue or C to check a hash..." key
  83. if [[ "$key" != 'c' && "$key" != 'C' ]]; then
  84. return
  85. fi
  86. data=$(mktemp 2>/dev/null)
  87. dialog --title $"Check tripwire hash" \
  88. --backtitle $"Freedombone Control Panel" \
  89. --inputbox $"Paste your tripwire hash below and it will be checked against the current database" 12 60 2>"$data"
  90. sel=$?
  91. case $sel in
  92. 0)
  93. GIVEN_HASH=$(<"$data")
  94. if [ ${#GIVEN_HASH} -gt 8 ]; then
  95. if [[ "$GIVEN_HASH" == *' '* ]]; then
  96. dialog --title $"Check tripwire" \
  97. --msgbox $"\\nThe hash should not contain any spaces" 10 40
  98. else
  99. DBHASH=$(sha512sum "/var/lib/tripwire/${HOSTNAME}.twd" | awk -F ' ' '{print $1}')
  100. if [[ "$DBHASH" == "$GIVEN_HASH" ]]; then
  101. dialog --title $"Check tripwire" \
  102. --msgbox $"\\nSuccess\\n\\nThe hash you gave matches the current tripwire database" 10 40
  103. else
  104. dialog --title $"Check tripwire" \
  105. --msgbox $"\\nFailed\\n\\nThe hash you gave does not match the current tripwire database. This might be because you reset the tripwire, or there could have been an unauthorised modification of the system" 12 50
  106. fi
  107. fi
  108. fi
  109. ;;
  110. esac
  111. rm -f "$data"
  112. }
  113. function show_tripwire_verification_code {
  114. if [ ! -f "/var/lib/tripwire/${HOSTNAME}.twd" ]; then
  115. return
  116. fi
  117. clear
  118. echo ''
  119. echo $'Tripwire Verification Code'
  120. echo ''
  121. DBHASH=$(sha512sum "/var/lib/tripwire/${HOSTNAME}.twd")
  122. echo -n "$DBHASH" | qrencode -t UTF8
  123. echo ''
  124. echo "$DBHASH"
  125. echo ''
  126. }
  127. function reset_tripwire {
  128. if [ ! -f /usr/bin/reset-tripwire ]; then
  129. echo $'Missing /usr/bin/reset-tripwire'
  130. any_key
  131. return
  132. fi
  133. if [ ! -f "/etc/tripwire/${HOSTNAME}-local.key" ]; then
  134. if [ -f "/etc/tripwire/${PROJECT_NAME}-local.key" ]; then
  135. # shellcheck disable=SC2086
  136. mv /etc/tripwire/${PROJECT_NAME}-local.key /etc/tripwire/${HOSTNAME}-local.key
  137. # shellcheck disable=SC2086
  138. mv /etc/tripwire/${PROJECT_NAME}-site.key /etc/tripwire/${HOSTNAME}-site.key
  139. else
  140. echo $'Error: missing local key'
  141. any_key
  142. return
  143. fi
  144. fi
  145. clear
  146. echo $'Turing off logging...'
  147. "${PROJECT_NAME}-logging" off
  148. echo $'Locking down permissions...'
  149. lockdown_permissions
  150. echo $'Creating configuration...'
  151. echo '
  152. ' | twadmin --create-cfgfile -S "/etc/tripwire/${HOSTNAME}-site.key" /etc/tripwire/twcfg.txt
  153. echo $'Resetting policy...'
  154. echo '
  155. ' | twadmin --create-polfile -S "/etc/tripwire/${HOSTNAME}-site.key" /etc/tripwire/twpol.txt
  156. echo $'Creating tripwire database'
  157. echo '
  158. ' | tripwire --init --cfgfile /etc/tripwire/tw.cfg --polfile /etc/tripwire/tw.pol --dbfile "/var/lib/tripwire/${HOSTNAME}.twd"
  159. echo $'Resetting the Tripwire...'
  160. echo ''
  161. echo '
  162. ' | reset-tripwire
  163. echo ''
  164. fuser -k 80/tcp
  165. fuser -k 443/tcp
  166. systemctl restart nginx
  167. if [ -f "/var/lib/tripwire/${HOSTNAME}.twd" ]; then
  168. show_tripwire_verification_code
  169. echo $'Tripwire is now reset. Take a note of the above hash, or record'
  170. echo $'the QR code using a mobile device. This will enable you to independently'
  171. echo $'verify the integrity of the tripwire.'
  172. else
  173. echo $'ERROR: tripwire database was not created'
  174. fi
  175. any_key
  176. }
  177. function passwords_show_apps {
  178. SELECTED_APP=
  179. i=0
  180. W=()
  181. name=()
  182. # shellcheck disable=SC2068
  183. for a in ${APPS_AVAILABLE[@]}
  184. do
  185. if grep -q "change_password_" "/usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-${a}"; then
  186. i=$((i+1))
  187. W+=("$i" "$a")
  188. name+=("$a")
  189. fi
  190. done
  191. i=$((i+1))
  192. W+=("$i" "mariadb")
  193. name+=("mariadb")
  194. # shellcheck disable=SC2068
  195. selected_app_index=$(dialog --backtitle $"Freedombone Control Panel" --title $"User $SELECTED_USERNAME: Select App" --menu $"Select one of the following:" 24 40 17 ${W[@]} 3>&2 2>&1 1>&3)
  196. # shellcheck disable=SC2181
  197. if [ $? -eq 0 ]; then
  198. SELECTED_APP="${name[$((selected_app_index-1))]}"
  199. fi
  200. }
  201. function view_or_change_passwords {
  202. passwords_select_user
  203. if [ ! "$SELECTED_USERNAME" ]; then
  204. return
  205. fi
  206. detect_installed_apps
  207. passwords_show_apps
  208. if [ ! "$SELECTED_APP" ]; then
  209. return
  210. fi
  211. CURR_PASSWORD=$("${PROJECT_NAME}-pass" -u "${SELECTED_USERNAME}" -a "${SELECTED_APP}")
  212. icann_address=$(get_app_icann_address "${SELECTED_APP}")
  213. onion_address=$(get_app_onion_address "${SELECTED_APP}")
  214. titlestr=$"View or Change Password"
  215. if [ ${#onion_address} -gt 0 ]; then
  216. viewstr=$"${SELECTED_APP} password for ${SELECTED_USERNAME} on $icann_address or $onion_address\\n\\nCopy or change it if you wish."
  217. else
  218. viewstr=$"${SELECTED_APP} password for ${SELECTED_USERNAME} on $icann_address\\n\\nCopy or change it if you wish."
  219. fi
  220. if [ -f /root/.nostore ]; then
  221. titlestr=$"Change Password"
  222. if [ ${#onion_address} -gt 0 ]; then
  223. viewstr=$"Change the ${SELECTED_APP} password for ${SELECTED_USERNAME} on $icann_address or $onion_address."
  224. else
  225. viewstr=$"Change the ${SELECTED_APP} password for ${SELECTED_USERNAME} on $icann_address."
  226. fi
  227. fi
  228. if [[ "${SELECTED_APP}" == 'mariadb' ]]; then
  229. CURR_PASSWORD=$("${PROJECT_NAME}-pass" -u root -a mariadb)
  230. dialog --title $"MariaDB database password" \
  231. --msgbox "\\n ${CURR_PASSWORD}" 7 40
  232. return
  233. fi
  234. data=$(mktemp 2>/dev/null)
  235. dialog --title "$titlestr" \
  236. --backtitle $"Freedombone Control Panel" \
  237. --inputbox "$viewstr" 12 75 "$CURR_PASSWORD" 2>"$data"
  238. sel=$?
  239. case $sel in
  240. 0)
  241. CURR_PASSWORD=$(<"$data")
  242. if [ ${#CURR_PASSWORD} -gt 8 ]; then
  243. "${PROJECT_NAME}-pass" -u "${SELECTED_USERNAME}" -a "${SELECTED_APP}" -p "${CURR_PASSWORD}"
  244. "change_password_${SELECTED_APP}" "${SELECTED_USERNAME}" "${CURR_PASSWORD}"
  245. dialog --title $"Change password" \
  246. --msgbox $"The password was changed" 6 40
  247. else
  248. dialog --title $"Change password" \
  249. --msgbox $"The password given must be at least 8 characters" 6 40
  250. fi
  251. ;;
  252. esac
  253. rm -f "$data"
  254. }
  255. function show_firewall {
  256. W=()
  257. while read -r line; do
  258. firewall_name=$(echo "$line" | awk -F '=' '{print $1}')
  259. firewall_port=$(echo "$line" | awk -F '=' '{print $2}')
  260. W+=("${firewall_name}" "${firewall_port}")
  261. done < "$FIREWALL_CONFIG"
  262. # shellcheck disable=SC2068
  263. dialog --backtitle $"Freedombone Administrator Control Panel" --title $"Firewall" --menu $"Press ESC to return to main menu" 28 50 28 "${W[@]}" 3>&2 2>&1 1>&3
  264. }
  265. function export_passwords {
  266. detect_usb_drive
  267. dialog --title $"Export passwords to USB drive $USB_DRIVE" \
  268. --backtitle $"Security Settings" \
  269. --defaultno \
  270. --yesno $"\\nPlease confirm that you wish to export passwords to a LUKS formatted USB drive. The drive should be plugged in." 10 60
  271. sel=$?
  272. case $sel in
  273. 1) return;;
  274. 255) return;;
  275. esac
  276. dialog --title $"Export passwords to USB drive $USB_DRIVE" \
  277. --backtitle $"Security Settings" \
  278. --defaultno \
  279. --yesno $"\\nDo you need to format the drive as LUKS encrypted?" 12 60
  280. sel=$?
  281. case $sel in
  282. 0) ${PROJECT_NAME}-format "$USB_DRIVE";;
  283. esac
  284. clear
  285. backup_mount_drive "${USB_DRIVE}"
  286. ${PROJECT_NAME}-pass --export "${USB_MOUNT}/${PROJECT_NAME}-passwords.xml"
  287. backup_unmount_drive "${USB_DRIVE}"
  288. }
  289. function get_protocols_from_website {
  290. if [ ! -f "$WEBSITES_DIRECTORY/$1" ]; then
  291. return
  292. fi
  293. SSL_PROTOCOLS=$(grep 'ssl_protocols ' "$WEBSITES_DIRECTORY/$1" | awk -F "ssl_protocols " '{print $2}' | awk -F ';' '{print $1}')
  294. }
  295. function get_ciphers_from_website {
  296. if [ ! -f "$WEBSITES_DIRECTORY/$1" ]; then
  297. return
  298. fi
  299. SSL_CIPHERS=$(grep 'ssl_ciphers ' "$WEBSITES_DIRECTORY/$1" | awk -F "ssl_ciphers " '{print $2}' | awk -F "'" '{print $2}')
  300. }
  301. function get_imap_settings {
  302. if [ ! -f $DOVECOT_CIPHERS ]; then
  303. return
  304. fi
  305. # clear commented out cipher list
  306. sed -i "s|#ssl_cipher_list.*||g" $DOVECOT_CIPHERS
  307. if [ "$SSL_CIPHERS" ]; then
  308. return
  309. fi
  310. if [ ${#SSL_CIPHERS} -gt $MINIMUM_LENGTH ]; then
  311. return
  312. fi
  313. SSL_CIPHERS=$(grep 'ssl_cipher_list' "$DOVECOT_CIPHERS" | awk -F '=' '{print $2}' | awk -F "'" '{print $2}')
  314. }
  315. function get_xmpp_settings {
  316. if [ ! -f $XMPP_CONFIG ]; then
  317. return
  318. fi
  319. XMPP_CIPHERS=$(grep 'ciphers ' "$XMPP_CONFIG" | awk -F '=' '{print $2}' | awk -F '"' '{print $2}')
  320. XMPP_ECC_CURVE=$(grep 'curve ' "$XMPP_CONFIG" | awk -F '=' '{print $2}' | awk -F '"' '{print $2}')
  321. }
  322. function get_ssh_settings {
  323. if [ -f $SSH_CONFIG ]; then
  324. SSH_PASSWORDS=$(grep 'PasswordAuthentication ' "$SSH_CONFIG" | awk -F 'PasswordAuthentication ' '{print $2}')
  325. fi
  326. if [ -f /etc/ssh/ssh_config ]; then
  327. SSH_HOST_KEY_ALGORITHMS=$(grep 'HostKeyAlgorithms ' "/etc/ssh/ssh_config" | awk -F 'HostKeyAlgorithms ' '{print $2}')
  328. fi
  329. }
  330. function change_website_settings {
  331. if [ ! "$SSL_PROTOCOLS" ]; then
  332. return
  333. fi
  334. if [ ! "$SSL_CIPHERS" ]; then
  335. return
  336. fi
  337. if [ ${#SSL_PROTOCOLS} -lt $MINIMUM_LENGTH ]; then
  338. return
  339. fi
  340. if [ ${#SSL_CIPHERS} -lt $MINIMUM_LENGTH ]; then
  341. return
  342. fi
  343. if [ ! -d $WEBSITES_DIRECTORY ]; then
  344. return
  345. fi
  346. cd $WEBSITES_DIRECTORY || exit 2468724628
  347. for file in $(dir -d "*") ; do
  348. sed -i "s|ssl_protocols .*|ssl_protocols $SSL_PROTOCOLS;|g" "$WEBSITES_DIRECTORY/$file"
  349. if ! grep -q "Mobile compatible ciphers" "$WEBSITES_DIRECTORY/$file"; then
  350. sed -i "s|ssl_ciphers .*|ssl_ciphers '$SSL_CIPHERS';|g" "$WEBSITES_DIRECTORY/$file"
  351. else
  352. sed -i "s|ssl_ciphers .*|ssl_ciphers '$SSL_CIPHERS_MOBILE';|g" "$WEBSITES_DIRECTORY/$file"
  353. fi
  354. done
  355. fuser -k 80/tcp
  356. fuser -k 443/tcp
  357. systemctl restart nginx
  358. echo $'Web security settings changed'
  359. }
  360. function change_imap_settings {
  361. if [ ! -f $DOVECOT_CIPHERS ]; then
  362. return
  363. fi
  364. if [ ! "$SSL_CIPHERS" ]; then
  365. return
  366. fi
  367. if [ ${#SSL_CIPHERS} -lt $MINIMUM_LENGTH ]; then
  368. return
  369. fi
  370. sed -i "s|ssl_cipher_list.*|ssl_cipher_list = '$SSL_CIPHERS'|g" $DOVECOT_CIPHERS
  371. sed -i "s|ssl_protocols.*|ssl_protocols = '$SSL_PROTOCOLS'|g" $DOVECOT_CIPHERS
  372. systemctl restart dovecot
  373. echo $'imap security settings changed'
  374. }
  375. function change_ssh_settings {
  376. if [ -f /etc/ssh/ssh_config ]; then
  377. if [ "$SSH_HOST_KEY_ALGORITHMS" ]; then
  378. sed -i "s|HostKeyAlgorithms .*|HostKeyAlgorithms $SSH_HOST_KEY_ALGORITHMS|g" /etc/ssh/ssh_config
  379. echo $'ssh client security settings changed'
  380. fi
  381. fi
  382. if [ -f $SSH_CONFIG ]; then
  383. if [ ! $SSH_CIPHERS ]; then
  384. return
  385. fi
  386. if [ ! $SSH_MACS ]; then
  387. return
  388. fi
  389. if [ ! $SSH_KEX ]; then
  390. return
  391. fi
  392. if [ ! "$SSH_PASSWORDS" ]; then
  393. SSH_PASSWORDS='yes'
  394. fi
  395. sed -i "s|Ciphers .*|Ciphers $SSH_CIPHERS|g" $SSH_CONFIG
  396. sed -i "s|MACs .*|MACs $SSH_MACS|g" $SSH_CONFIG
  397. sed -i "s|KexAlgorithms .*|KexAlgorithms $SSH_KEX|g" $SSH_CONFIG
  398. sed -i "s|#PasswordAuthentication .*|PasswordAuthentication $SSH_PASSWORDS|g" $SSH_CONFIG
  399. sed -i "s|PasswordAuthentication .*|PasswordAuthentication $SSH_PASSWORDS|g" $SSH_CONFIG
  400. systemctl restart ssh
  401. echo $'ssh server security settings changed'
  402. fi
  403. }
  404. function change_xmpp_settings {
  405. if [ ! -f $XMPP_CONFIG ]; then
  406. return
  407. fi
  408. if [ ! "$XMPP_CIPHERS" ]; then
  409. return
  410. fi
  411. if [ ! "$XMPP_ECC_CURVE" ]; then
  412. return
  413. fi
  414. sed -i "s|ciphers =.*|ciphers = \"$XMPP_CIPHERS\";|g" $XMPP_CONFIG
  415. sed -i "s|curve =.*|curve = \"$XMPP_ECC_CURVE\";|g" $XMPP_CONFIG
  416. systemctl restart prosody
  417. echo $'xmpp security settings changed'
  418. }
  419. function allow_ssh_passwords {
  420. dialog --title $"SSH Passwords" \
  421. --backtitle $"Freedombone Security Configuration" \
  422. --yesno $"\\nAllow SSH login using passwords?" 7 60
  423. sel=$?
  424. case $sel in
  425. 0) SSH_PASSWORDS="yes";;
  426. 1) SSH_PASSWORDS="no";;
  427. 255) exit 0;;
  428. esac
  429. }
  430. function interactive_setup {
  431. if [ "$SSL_CIPHERS" ]; then
  432. data=$(mktemp 2>/dev/null)
  433. dialog --backtitle $"Freedombone Security Configuration" \
  434. --form $"\\nWeb/IMAP Ciphers:" 10 95 2 \
  435. $"Protocols:" 1 1 "$SSL_PROTOCOLS" 1 15 90 90 \
  436. $"Ciphers:" 2 1 "$SSL_CIPHERS" 2 15 90 512 \
  437. 2> "$data"
  438. sel=$?
  439. case $sel in
  440. 1) SSL_PROTOCOLS=$(sed -n 1p < "$data")
  441. SSL_CIPHERS=$(sed -n 2p < "$data")
  442. ;;
  443. 255) rm -f "$data"
  444. exit 0;;
  445. esac
  446. rm -f "$data"
  447. fi
  448. data=$(mktemp 2>/dev/null)
  449. if [ "$SSH_HOST_KEY_ALGORITHMS" ]; then
  450. dialog --backtitle $"Freedombone Security Configuration" \
  451. --form $"\\nSecure Shell Ciphers:" 13 95 4 \
  452. $"Ciphers:" 1 1 "$SSH_CIPHERS" 1 15 90 512 \
  453. $"MACs:" 2 1 "$SSH_MACS" 2 15 90 512 \
  454. $"KEX:" 3 1 "$SSH_KEX" 3 15 90 512 \
  455. $"Host key algorithms:" 4 1 "$SSH_HOST_KEY_ALGORITHMS" 4 15 90 512 \
  456. 2> "$data"
  457. sel=$?
  458. case $sel in
  459. 1) SSH_CIPHERS=$(sed -n 1p < "$data")
  460. SSH_MACS=$(sed -n 2p < "$data")
  461. SSH_KEX=$(sed -n 3p < "$data")
  462. SSH_HOST_KEY_ALGORITHMS=$(sed -n 4p < "$data")
  463. ;;
  464. 255) rm -f "$data"
  465. exit 0;;
  466. esac
  467. else
  468. dialog --backtitle $"Freedombone Security Configuration" \
  469. --form $"\\nSecure Shell Ciphers:" 11 95 3 \
  470. $"Ciphers:" 1 1 "$SSH_CIPHERS" 1 15 90 512 \
  471. $"MACs:" 2 1 "$SSH_MACS" 2 15 90 512 \
  472. $"KEX:" 3 1 "$SSH_KEX" 3 15 90 512 \
  473. 2> "$data"
  474. sel=$?
  475. case $sel in
  476. 1) SSH_CIPHERS=$(sed -n 1p < "$data")
  477. SSH_MACS=$(sed -n 2p < "$data")
  478. SSH_KEX=$(sed -n 3p < "$data")
  479. ;;
  480. 255) rm -f "$data"
  481. exit 0;;
  482. esac
  483. fi
  484. rm -f "$data"
  485. if [ "$XMPP_CIPHERS" ]; then
  486. data=$(mktemp 2>/dev/null)
  487. dialog --backtitle $"Freedombone Security Configuration" \
  488. --form $"\\nXMPP Ciphers:" 10 95 2 \
  489. $"Ciphers:" 1 1 "$XMPP_CIPHERS" 1 15 90 512 \
  490. $"ECC Curve:" 2 1 "$XMPP_ECC_CURVE" 2 15 50 50 \
  491. 2> "$data"
  492. sel=$?
  493. case $sel in
  494. 1) XMPP_CIPHERS=$(sed -n 1p < "$data")
  495. XMPP_ECC_CURVE=$(sed -n 2p < "$data")
  496. ;;
  497. 255) rm -f "$data"
  498. exit 0;;
  499. esac
  500. rm -f "$data"
  501. fi
  502. dialog --title $"Final Confirmation" \
  503. --backtitle $"Freedombone Security Configuration" \
  504. --defaultno \
  505. --yesno $"\\nPlease confirm that you wish your security settings to be changed?\\n\\nWARNING: any mistakes made in the security settings could compromise your system, so be extra careful when answering 'yes'." 12 60
  506. sel=$?
  507. case $sel in
  508. 1) clear
  509. echo $'Exiting without changing security settings'
  510. exit 0;;
  511. 255) clear
  512. echo $'Exiting without changing security settings'
  513. exit 0;;
  514. esac
  515. clear
  516. }
  517. function send_monkeysphere_server_keys_to_users {
  518. monkeysphere_server_keys=$(monkeysphere-host show-key | grep $"OpenPGP fingerprint" | awk -F ' ' '{print $3}')
  519. for d in /home/*/ ; do
  520. USERNAME=$(echo "$d" | awk -F '/' '{print $3}')
  521. if [[ $(is_valid_user "$USERNAME") == "1" ]]; then
  522. if [ ! -d "/home/$USERNAME/.monkeysphere" ]; then
  523. mkdir "/home/$USERNAME/.monkeysphere"
  524. fi
  525. echo "$monkeysphere_server_keys" > "/home/$USERNAME/.monkeysphere/server_keys"
  526. chown -R "$USERNAME":"$USERNAME" "/home/$USERNAME/.monkeysphere"
  527. fi
  528. done
  529. }
  530. function regenerate_ssh_host_keys {
  531. rm -f /etc/ssh/ssh_host_*
  532. dpkg-reconfigure openssh-server
  533. echo $'ssh host keys regenerated'
  534. # remove small moduli
  535. awk '$5 > 2000' /etc/ssh/moduli > ~/moduli
  536. mv ~/moduli /etc/ssh/moduli
  537. echo $'ssh small moduli removed'
  538. # update monkeysphere
  539. DEFAULT_DOMAIN_NAME=
  540. read_config_param "DEFAULT_DOMAIN_NAME"
  541. monkeysphere-host import-key /etc/ssh/ssh_host_rsa_key "ssh://$DEFAULT_DOMAIN_NAME"
  542. SSH_ONION_HOSTNAME=$(grep 'ssh onion domain' "${COMPLETION_FILE}" | awk -F ':' '{print $2}')
  543. monkeysphere-host import-key /etc/ssh/ssh_host_rsa_key "ssh://$SSH_ONION_HOSTNAME"
  544. monkeysphere-host publish-key
  545. send_monkeysphere_server_keys_to_users
  546. echo $'updated monkeysphere ssh host key'
  547. systemctl restart ssh
  548. }
  549. function regenerate_dh_keys {
  550. if [ ! -d /etc/ssl/mycerts ]; then
  551. echo $'No dhparam certificates were found'
  552. return
  553. fi
  554. data=$(mktemp 2>/dev/null)
  555. dialog --backtitle "Freedombone Security Configuration" \
  556. --title "Diffie-Hellman key length" \
  557. --radiolist "The smaller length is better suited to low power embedded systems:" 12 40 3 \
  558. 1 "2048 bits" off \
  559. 2 "3072 bits" on \
  560. 3 "4096 bits" off 2> "$data"
  561. sel=$?
  562. case $sel in
  563. 1) rm -f "$data"
  564. exit 1;;
  565. 255) rm -f "$data"
  566. exit 1;;
  567. esac
  568. case $(cat "$data") in
  569. 1) DH_KEYLENGTH=2048;;
  570. 2) DH_KEYLENGTH=3072;;
  571. 3) DH_KEYLENGTH=4096;;
  572. esac
  573. rm -f "$data"
  574. ${PROJECT_NAME}-dhparam --recalc yes -l ${DH_KEYLENGTH}
  575. }
  576. function renew_startssl {
  577. renew_domain=
  578. data=$(mktemp 2>/dev/null)
  579. dialog --title $"Renew a StartSSL certificate" \
  580. --backtitle $"Freedombone Security Settings" \
  581. --inputbox $"Enter the domain name" 8 60 2>"$data"
  582. sel=$?
  583. case $sel in
  584. 0)
  585. renew_domain=$(<"$data")
  586. ;;
  587. esac
  588. rm -f "$data"
  589. if [ ! "$renew_domain" ]; then
  590. return
  591. fi
  592. if [[ $renew_domain == "http"* ]]; then
  593. dialog --title $"Renew a StartSSL certificate" \
  594. --msgbox $"Don't include the https://" 6 40
  595. return
  596. fi
  597. if [ ! -f "/etc/ssl/certs/${renew_domain}.dhparam" ]; then
  598. dialog --title $"Renew a StartSSL certificate" \
  599. --msgbox $"An existing certificate for $renew_domain was not found" 6 40
  600. return
  601. fi
  602. if [[ $renew_domain != *"."* ]]; then
  603. dialog --title $"Renew a StartSSL certificate" \
  604. --msgbox $"Invalid domain name: $renew_domain" 6 40
  605. return
  606. fi
  607. ${PROJECT_NAME}-renew-cert -h "$renew_domain" -p startssl
  608. exit 0
  609. }
  610. function renew_letsencrypt {
  611. renew_domain=
  612. data=$(mktemp 2>/dev/null)
  613. dialog --title $"Renew a Let's Encrypt certificate" \
  614. --backtitle $"Freedombone Security Settings" \
  615. --inputbox $"Enter the domain name" 8 60 2>"$data"
  616. sel=$?
  617. case $sel in
  618. 0)
  619. renew_domain=$(<"$data")
  620. ;;
  621. esac
  622. rm -f "$data"
  623. if [ ! "$renew_domain" ]; then
  624. return
  625. fi
  626. if [[ $renew_domain == "http"* ]]; then
  627. dialog --title $"Renew a Let's Encrypt certificate" \
  628. --msgbox $"Don't include the https://" 6 40
  629. return
  630. fi
  631. if [ ! -f "/etc/ssl/certs/${renew_domain}.dhparam" ]; then
  632. dialog --title $"Renew a Let's Encrypt certificate" \
  633. --msgbox $"An existing certificate for $renew_domain was not found" 6 40
  634. return
  635. fi
  636. if [[ $renew_domain != *"."* ]]; then
  637. dialog --title $"Renew a Let's Encrypt certificate" \
  638. --msgbox $"Invalid domain name: $renew_domain" 6 40
  639. return
  640. fi
  641. ${PROJECT_NAME}-renew-cert -h "$renew_domain" -p 'letsencrypt'
  642. exit 0
  643. }
  644. function delete_letsencrypt {
  645. delete_domain=
  646. data=$(mktemp 2>/dev/null)
  647. dialog --title $"Delete a Let's Encrypt certificate" \
  648. --backtitle $"Freedombone Security Settings" \
  649. --inputbox $"Enter the domain name" 8 60 2>"$data"
  650. sel=$?
  651. case $sel in
  652. 0)
  653. delete_domain=$(<"$data")
  654. ;;
  655. esac
  656. rm -f "$data"
  657. if [ ! "$delete_domain" ]; then
  658. return
  659. fi
  660. if [[ $delete_domain == "http"* ]]; then
  661. dialog --title $"Delete a Let's Encrypt certificate" \
  662. --msgbox $"Don't include the https://" 6 40
  663. return
  664. fi
  665. if [ ! -f "/etc/ssl/certs/${delete_domain}.dhparam" ]; then
  666. dialog --title $"Delete a Let's Encrypt certificate" \
  667. --msgbox $"An existing certificate for $renew_domain was not found" 6 40
  668. return
  669. fi
  670. if [[ $delete_domain != *"."* ]]; then
  671. dialog --title $"Delete a Let's Encrypt certificate" \
  672. --msgbox $"Invalid domain name: $delete_domain" 6 40
  673. return
  674. fi
  675. dialog --title $"Delete a Let's Encrypt certificate" \
  676. --backtitle $"Freedombone Security Settings" \
  677. --defaultno \
  678. --yesno $"\\nConfirm deletion of the TLS certificate for $delete_domain ?" 7 60
  679. sel=$?
  680. case $sel in
  681. 0) ${PROJECT_NAME}-addcert -r "$delete_domain";;
  682. 255) exit 0;;
  683. esac
  684. exit 0
  685. }
  686. function create_letsencrypt {
  687. new_domain=
  688. data=$(mktemp 2>/dev/null)
  689. dialog --title $"Create a new Let's Encrypt certificate" \
  690. --backtitle $"Freedombone Security Settings" \
  691. --inputbox $"Enter the domain name" 8 60 2>"$data"
  692. sel=$?
  693. case $sel in
  694. 0)
  695. new_domain=$(<"$data")
  696. ;;
  697. esac
  698. rm -f "$data"
  699. if [ ! "$new_domain" ]; then
  700. return
  701. fi
  702. if [[ $new_domain == "http"* ]]; then
  703. dialog --title $"Create a new Let's Encrypt certificate" \
  704. --msgbox $"Don't include the https://" 6 40
  705. return
  706. fi
  707. if [[ $new_domain != *"."* ]]; then
  708. dialog --title $"Create a new Let's Encrypt certificate" \
  709. --msgbox $"Invalid domain name: $new_domain" 6 40
  710. return
  711. fi
  712. if [ ! -d "/var/www/${new_domain}" ]; then
  713. domain_found=
  714. if [ -f /etc/nginx/sites-available/radicale ]; then
  715. if grep -q "${new_domain}" /etc/nginx/sites-available/radicale; then
  716. domain_found=1
  717. fi
  718. fi
  719. if [ -f "/etc/nginx/sites-available/${new_domain}" ]; then
  720. domain_found=1
  721. fi
  722. if [[ "${new_domain}" == "jitsi"* || "${new_domain}" == "meet"* ]]; then
  723. domain_found=1
  724. fi
  725. if [ ! $domain_found ]; then
  726. dialog --title $"Create a new Let's Encrypt certificate" \
  727. --msgbox $'Domain not found within /var/www' 6 40
  728. return
  729. fi
  730. fi
  731. ${PROJECT_NAME}-addcert -e "$new_domain" -s "$LETSENCRYPT_SERVER" --dhkey "$DH_KEYLENGTH"
  732. exit 0
  733. }
  734. function update_ciphersuite {
  735. RECOMMENDED_SSL_CIPHERS="$SSL_CIPHERS"
  736. if [ ${#RECOMMENDED_SSL_CIPHERS} -lt 5 ]; then
  737. return
  738. fi
  739. RECOMMENDED_SSL_PROTOCOLS="$SSL_PROTOCOLS"
  740. if [ ${#RECOMMENDED_SSL_PROTOCOLS} -lt 5 ]; then
  741. return
  742. fi
  743. RECOMMENDED_SSH_CIPHERS="$SSH_CIPHERS"
  744. if [ ${#RECOMMENDED_SSH_CIPHERS} -lt 5 ]; then
  745. return
  746. fi
  747. RECOMMENDED_SSH_MACS="$SSH_MACS"
  748. if [ ${#RECOMMENDED_SSH_MACS} -lt 5 ]; then
  749. return
  750. fi
  751. RECOMMENDED_SSH_KEX="$SSH_KEX"
  752. if [ ${#RECOMMENDED_SSH_KEX} -lt 5 ]; then
  753. return
  754. fi
  755. cd $WEBSITES_DIRECTORY || exit 728425476
  756. for file in $(dir -d "*") ; do
  757. sed -i "s|ssl_protocols .*|ssl_protocols $RECOMMENDED_SSL_PROTOCOLS;|g" "$WEBSITES_DIRECTORY/$file"
  758. if ! grep -q "Mobile compatible ciphers" "$WEBSITES_DIRECTORY/$file"; then
  759. sed -i "s|ssl_ciphers .*|ssl_ciphers '$RECOMMENDED_SSL_CIPHERS';|g" "$WEBSITES_DIRECTORY/$file"
  760. else
  761. sed -i "s|ssl_ciphers .*|ssl_ciphers '$SSL_CIPHERS_MOBILE';|g" "$WEBSITES_DIRECTORY/$file"
  762. fi
  763. done
  764. fuser -k 80/tcp
  765. fuser -k 443/tcp
  766. systemctl restart nginx
  767. write_config_param "SSL_PROTOCOLS" "$RECOMMENDED_SSL_PROTOCOLS"
  768. write_config_param "SSL_CIPHERS" "$RECOMMENDED_SSL_CIPHERS"
  769. sed -i "s|Ciphers .*|Ciphers $RECOMMENDED_SSH_CIPHERS|g" $SSH_CONFIG
  770. sed -i "s|MACs .*|MACs $RECOMMENDED_SSH_MACS|g" $SSH_CONFIG
  771. sed -i "s|KexAlgorithms .*|KexAlgorithms $RECOMMENDED_SSH_KEX|g" $SSH_CONFIG
  772. systemctl restart ssh
  773. write_config_param "SSH_CIPHERS" "$RECOMMENDED_SSH_CIPHERS"
  774. write_config_param "SSH_MACS" "$RECOMMENDED_SSH_MACS"
  775. write_config_param "SSH_KEX" "$RECOMMENDED_SSH_KEX"
  776. dialog --title $"Update ciphersuite" \
  777. --msgbox $"The ciphersuite has been updated to recommended versions" 6 40
  778. exit 0
  779. }
  780. function enable_monkeysphere {
  781. monkey=
  782. dialog --title $"GPG based authentication" \
  783. --backtitle $"Freedombone Security Configuration" \
  784. --defaultno \
  785. --yesno $"\\nEnable GPG based authentication with monkeysphere ?" 7 60
  786. sel=$?
  787. case $sel in
  788. 0) monkey='yes';;
  789. 255) exit 0;;
  790. esac
  791. if [ $monkey ]; then
  792. read_config_param "MY_USERNAME"
  793. if [ ! -f /home/$MY_USERNAME/.monkeysphere/authorized_user_ids ]; then
  794. dialog --title $"GPG based authentication" \
  795. --msgbox $"$MY_USERNAME does not currently have any ids within ~/.monkeysphere/authorized_user_ids" 6 40
  796. exit 0
  797. fi
  798. MY_GPG_PUBLIC_KEY_ID=$(gpg_pubkey_from_email "$MY_USERNAME" "$MY_USERNAME@$HOSTNAME")
  799. if [ ${#MY_GPG_PUBLIC_KEY_ID} -lt 4 ]; then
  800. echo $"monkeysphere unable to get GPG key ID for user $MY_USERNAME@$HOSTNAME"
  801. exit 52825
  802. fi
  803. sed -i 's|#AuthorizedKeysFile|AuthorizedKeysFile|g' /etc/ssh/sshd_config
  804. sed -i 's|AuthorizedKeysFile.*|AuthorizedKeysFile /var/lib/monkeysphere/authorized_keys/%u|g' /etc/ssh/sshd_config
  805. monkeysphere-authentication update-users
  806. # The admin user is the identity certifier
  807. fpr=$(gpg --with-colons --fingerprint "$MY_GPG_PUBLIC_KEY_ID" | grep fpr | head -n 1 | awk -F ':' '{print $10}')
  808. monkeysphere-authentication add-identity-certifier "$fpr"
  809. monkeysphere-host publish-key
  810. send_monkeysphere_server_keys_to_users
  811. else
  812. sed -i 's|#AuthorizedKeysFile|AuthorizedKeysFile|g' /etc/ssh/sshd_config
  813. sed -i 's|AuthorizedKeysFile.*|AuthorizedKeysFile %h/.ssh/authorized_keys|g' /etc/ssh/sshd_config
  814. fi
  815. systemctl restart ssh
  816. if [ $monkey ]; then
  817. dialog --title $"GPG based authentication" \
  818. --msgbox $"GPG based authentication was enabled" 6 40
  819. else
  820. dialog --title $"GPG based authentication" \
  821. --msgbox $"GPG based authentication was disabled" 6 40
  822. fi
  823. exit 0
  824. }
  825. function register_website {
  826. domain="$1"
  827. if [[ ${domain} == *".local" ]]; then
  828. echo $"Can't register local domains"
  829. return
  830. fi
  831. if [ ! -f "/etc/ssl/private/${domain}.key" ]; then
  832. echo $"No SSL/TLS private key found for ${domain}"
  833. return
  834. fi
  835. if [ ! -f "/etc/nginx/sites-available/${domain}" ]; then
  836. echo $"No virtual host found for ${domain}"
  837. return
  838. fi
  839. monkeysphere-host import-key "/etc/ssl/private/${domain}.key" "https://${domain}"
  840. monkeysphere-host publish-key
  841. echo "0"
  842. }
  843. function register_website_interactive {
  844. data=$(mktemp 2>/dev/null)
  845. dialog --title $"Register a website with monkeysphere" \
  846. --backtitle $"Freedombone Security Settings" \
  847. --inputbox $"Enter the website domain name (without https://)" 8 60 2>"$data"
  848. sel=$?
  849. case $sel in
  850. 0)
  851. domain=$(<"$data")
  852. if ! register_website "$domain"; then
  853. dialog --title $"Register a website with monkeysphere" \
  854. --msgbox "$?" 6 40
  855. else
  856. dialog --title $"Register a website with monkeysphere" \
  857. --msgbox $"$domain has been registered" 6 40
  858. fi
  859. ;;
  860. esac
  861. rm -f "$data"
  862. }
  863. function pin_all_tls_certs {
  864. ${PROJECT_NAME}-pin-cert all
  865. }
  866. function remove_pinning {
  867. data=$(mktemp 2>/dev/null)
  868. dialog --title $"Remove pinning for a domain" \
  869. --backtitle $"Freedombone Security Settings" \
  870. --inputbox $"Enter the website domain name (without https://)" 8 60 2>"$data"
  871. sel=$?
  872. case $sel in
  873. 0)
  874. domain=$(<"$data")
  875. if ! ${PROJECT_NAME}-pin-cert "$domain" remove; then
  876. dialog --title $"Removed pinning from $domain" \
  877. --msgbox "$?" 6 40
  878. fi
  879. ;;
  880. esac
  881. rm -f "$data"
  882. }
  883. function store_passwords {
  884. dialog --title $"Store Passwords" \
  885. --backtitle $"Freedombone Security Configuration" \
  886. --yesno $"\\nDo you wish to store passwords on the system? Stored passwords are convenient but carry some additional security risk." 10 60
  887. sel=$?
  888. case $sel in
  889. 0)
  890. if [ -f /root/.nostore ]; then
  891. read_config_param "MY_USERNAME"
  892. if [ ! -f /home/$MY_USERNAME/.ssh/authorized_keys ]; then
  893. dialog --title $"Store Passwords" \
  894. --msgbox $"\\nYou should first enable key based ssh login to improve security" 8 60
  895. return
  896. fi
  897. if [[ $SSH_PASSWORDS == 'yes' ]]; then
  898. dialog --title $"Store Passwords" \
  899. --msgbox $"\\nYou should disable ssh passwords to improve security" 8 60
  900. return
  901. fi
  902. ${PROJECT_NAME}-pass --enable yes
  903. dialog --title $"Store Passwords" \
  904. --msgbox $"\\nUser passwords will now be stored on the system" 8 60
  905. fi
  906. return
  907. ;;
  908. 1)
  909. ${PROJECT_NAME}-pass --clear yes
  910. dialog --title $"Passwords were removed and will not be stored" \
  911. --msgbox $"\\nFor the best security you should now manually change passwords via web interfaces so that there is no possibility of them being recovered from the disk" 9 60
  912. return
  913. ;;
  914. 255) return;;
  915. esac
  916. }
  917. function show_tor_bridges {
  918. clear
  919. bridges_list=$(grep "Bridge " /etc/tor/torrc | grep -v '##')
  920. if [ ${#bridges_list} -eq 0 ]; then
  921. echo $'No Tor bridges have been added'
  922. return
  923. fi
  924. echo "${bridges_list}"
  925. }
  926. function add_tor_bridge {
  927. data=$(mktemp 2>/dev/null)
  928. dialog --backtitle $"Freedombone Control Panel" \
  929. --title $"Add obfs4 Tor bridge" \
  930. --form "\\n" 9 60 4 \
  931. $"IP address: " 1 1 " . . . " 1 17 16 16 \
  932. $"Port: " 2 1 "" 2 17 8 8 \
  933. $"Key/Nickname: " 3 1 "" 3 17 250 250 \
  934. 2> "$data"
  935. sel=$?
  936. case $sel in
  937. 1) rm -f "$data"
  938. return;;
  939. 255) rm -f "$data"
  940. return;;
  941. esac
  942. bridge_ip_address=$(sed -n 1p < "$data")
  943. bridge_port=$(sed -n 2p < "$data")
  944. bridge_key=$(sed -n 3p < "$data")
  945. rm -f "$data"
  946. if [[ "${bridge_ip_address}" == *" "* ]]; then
  947. return
  948. fi
  949. if [[ "${bridge_ip_address}" != *"."* ]]; then
  950. return
  951. fi
  952. if [ ${#bridge_port} -eq 0 ]; then
  953. return
  954. fi
  955. if [ ${#bridge_key} -eq 0 ]; then
  956. return
  957. fi
  958. tor_add_bridge "${bridge_ip_address}" "${bridge_port}" "${bridge_key}"
  959. dialog --title $"Add obfs4 Tor bridge" \
  960. --msgbox $"Bridge added" 6 40
  961. }
  962. function remove_tor_bridge {
  963. bridge_removed=
  964. data=$(mktemp 2>/dev/null)
  965. dialog --title $"Remove obfs4 Tor bridge" \
  966. --backtitle $"Freedombone Control Panel" \
  967. --inputbox $"Enter the IP address, key or Nickname of the bridge" 8 65 2>"$data"
  968. sel=$?
  969. case $sel in
  970. 0)
  971. response=$(<"$data")
  972. if [ ${#response} -gt 2 ]; then
  973. if [[ "${response}" != *" "* ]]; then
  974. if [[ "${response}" == *"."* ]]; then
  975. if grep -q "Bridge ${response}" /etc/tor/torrc; then
  976. tor_remove_bridge "${response}"
  977. bridge_removed=1
  978. fi
  979. else
  980. if grep -q " $response" /etc/tor/torrc; then
  981. tor_remove_bridge "${response}"
  982. bridge_removed=1
  983. fi
  984. fi
  985. fi
  986. fi
  987. ;;
  988. esac
  989. rm -f "$data"
  990. if [ $bridge_removed ]; then
  991. dialog --title $"Remove obfs4 Tor bridge" \
  992. --msgbox $"Bridge removed" 6 40
  993. fi
  994. }
  995. function add_tor_bridge_relay {
  996. read_config_param 'TOR_BRIDGE_NICKNAME'
  997. read_config_param 'TOR_BRIDGE_PORT'
  998. # remove any previous bridge port from the firewall
  999. if [ ${#TOR_BRIDGE_PORT} -gt 0 ]; then
  1000. firewall_remove "$TOR_BRIDGE_PORT" tcp
  1001. fi
  1002. data=$(mktemp 2>/dev/null)
  1003. dialog --backtitle $"Freedombone Control Panel" \
  1004. --title $"Become an obfs4 Tor bridge relay" \
  1005. --form "\\n" 8 60 2 \
  1006. $"Bridge Nickname: " 1 1 "$TOR_BRIDGE_NICKNAME" 1 20 250 250 \
  1007. 2> "$data"
  1008. sel=$?
  1009. case $sel in
  1010. 1) rm -f "$data"
  1011. return;;
  1012. 255) rm -f "$data"
  1013. return;;
  1014. esac
  1015. bridge_nickname=$(sed -n 1p < "$data")
  1016. rm -f "$data"
  1017. if [[ "${bridge_nickname}" == *" "* ]]; then
  1018. return
  1019. fi
  1020. if [ ${#bridge_nickname} -eq 0 ]; then
  1021. return
  1022. fi
  1023. TOR_BRIDGE_NICKNAME="$bridge_nickname"
  1024. TOR_BRIDGE_PORT=$((20000 + RANDOM % 40000))
  1025. write_config_param 'TOR_BRIDGE_NICKNAME' "$TOR_BRIDGE_NICKNAME"
  1026. write_config_param 'TOR_BRIDGE_PORT' "$TOR_BRIDGE_PORT"
  1027. tor_create_bridge_relay
  1028. dialog --title $"You are now an obfs4 Tor bridge relay" \
  1029. --msgbox $"\\nIP address: $(get_ipv4_address)\\n\\nPort: ${TOR_BRIDGE_PORT}\\n\\nNickname: ${TOR_BRIDGE_NICKNAME}" 10 65
  1030. }
  1031. function remove_tor_bridge_relay {
  1032. tor_remove_bridge_relay
  1033. dialog --title $"Remove Tor bridge relay" \
  1034. --msgbox $"Bridge relay removed" 10 60
  1035. }
  1036. function menu_tor_bridges {
  1037. W=(1 $"Show bridges"
  1038. 2 $"Add a bridge"
  1039. 3 $"Remove a bridge"
  1040. 4 $"Make this system into a bridge"
  1041. 5 $"Stop being a bridge")
  1042. # shellcheck disable=SC2068
  1043. selection=$(dialog --backtitle $"Freedombone Administrator Control Panel" --title $"Security Settings" --menu $"Choose an operation, or ESC to go back:" 14 50 6 "${W[@]}" 3>&2 2>&1 1>&3)
  1044. if [ ! "$selection" ]; then
  1045. exit 0
  1046. fi
  1047. case $selection in
  1048. 1)
  1049. show_tor_bridges
  1050. exit 0
  1051. ;;
  1052. 2)
  1053. add_tor_bridge
  1054. exit 0
  1055. ;;
  1056. 3)
  1057. remove_tor_bridge
  1058. exit 0
  1059. ;;
  1060. 4)
  1061. add_tor_bridge_relay
  1062. exit 0
  1063. ;;
  1064. 5)
  1065. remove_tor_bridge_relay
  1066. exit 0
  1067. ;;
  1068. esac
  1069. }
  1070. function menu_security_settings {
  1071. W=(1 $"Passwords"
  1072. 2 $"Run STIG tests"
  1073. 3 $"Fix STIG test failures"
  1074. 4 $"Show tripwire verification code"
  1075. 5 $"Reset tripwire"
  1076. 6 $"Enable or disable ping"
  1077. 7 $"Show ssh host public key"
  1078. 8 $"Tor bridges"
  1079. 9 $"Password storage"
  1080. 10 $"Export passwords"
  1081. 11 $"Regenerate ssh host keys"
  1082. 12 $"Regenerate Diffie-Hellman keys"
  1083. 13 $"Update cipersuite"
  1084. 14 $"Create a new Let's Encrypt certificate"
  1085. 15 $"Renew Let's Encrypt certificate"
  1086. 16 $"Delete a Let's Encrypt certificate"
  1087. 17 $"Allow ssh login with passwords"
  1088. 18 $"Show firewall")
  1089. # shellcheck disable=SC2068
  1090. selection=$(dialog --backtitle $"Freedombone Administrator Control Panel" --title $"Security Settings" --menu $"Choose an operation, or ESC to exit:" 25 76 25 "${W[@]}" 3>&2 2>&1 1>&3)
  1091. if [ ! "$selection" ]; then
  1092. exit 0
  1093. fi
  1094. clear
  1095. read_config_param SSL_CIPHERS
  1096. read_config_param SSL_PROTOCOLS
  1097. read_config_param SSH_CIPHERS
  1098. read_config_param SSH_MACS
  1099. read_config_param SSH_KEX
  1100. get_imap_settings
  1101. get_ssh_settings
  1102. get_xmpp_settings
  1103. import_settings
  1104. export_settings
  1105. case $selection in
  1106. 1)
  1107. view_or_change_passwords
  1108. exit 0;
  1109. ;;
  1110. 2)
  1111. clear
  1112. echo $'Running STIG tests...'
  1113. echo ''
  1114. ${PROJECT_NAME}-tests --stig showall
  1115. exit 0
  1116. ;;
  1117. 3)
  1118. clear
  1119. echo $'Fixing any STIG failures...'
  1120. echo ''
  1121. ${PROJECT_NAME}-tests --stig fix
  1122. echo $'Fixes applied. You will need to run the STIG tests again to be sure that they were all fixed.'
  1123. exit 0
  1124. ;;
  1125. 4)
  1126. show_tripwire_verification_code
  1127. any_key_verify
  1128. exit 0
  1129. ;;
  1130. 5)
  1131. reset_tripwire
  1132. exit 0
  1133. ;;
  1134. 6)
  1135. ping_enable_disable
  1136. exit 0
  1137. ;;
  1138. 7)
  1139. dialog --title $"SSH host public keys" \
  1140. --msgbox "\\n$(get_ssh_server_key)" 12 60
  1141. exit 0
  1142. ;;
  1143. 8)
  1144. menu_tor_bridges
  1145. exit 0
  1146. ;;
  1147. 9)
  1148. store_passwords
  1149. exit 0
  1150. ;;
  1151. 10)
  1152. export_passwords
  1153. exit 0
  1154. ;;
  1155. 11)
  1156. regenerate_ssh_host_keys
  1157. ;;
  1158. 12)
  1159. regenerate_dh_keys
  1160. ;;
  1161. 13)
  1162. interactive_setup
  1163. update_ciphersuite
  1164. ;;
  1165. 14)
  1166. create_letsencrypt
  1167. ;;
  1168. 15)
  1169. renew_letsencrypt
  1170. ;;
  1171. 16)
  1172. delete_letsencrypt
  1173. ;;
  1174. 17)
  1175. allow_ssh_passwords
  1176. change_ssh_settings
  1177. exit 0
  1178. ;;
  1179. 18)
  1180. show_firewall
  1181. exit 0
  1182. ;;
  1183. esac
  1184. change_website_settings
  1185. change_imap_settings
  1186. change_ssh_settings
  1187. change_xmpp_settings
  1188. }
  1189. function import_settings {
  1190. cd "$CURRENT_DIR" || exit 2468724684
  1191. if [ ! $IMPORT_FILE ]; then
  1192. return
  1193. fi
  1194. if [ ! -f $IMPORT_FILE ]; then
  1195. echo $"Import file $IMPORT_FILE not found"
  1196. exit 6393
  1197. fi
  1198. if grep -q "SSL_PROTOCOLS" $IMPORT_FILE; then
  1199. TEMP_VALUE=$(grep "SSL_PROTOCOLS" $IMPORT_FILE | awk -F '=' '{print $2}')
  1200. if [ ${#TEMP_VALUE} -gt $MINIMUM_LENGTH ]; then
  1201. SSL_PROTOCOLS=$TEMP_VALUE
  1202. fi
  1203. fi
  1204. if grep -q "SSL_CIPHERS" $IMPORT_FILE; then
  1205. TEMP_VALUE=$(grep "SSL_CIPHERS" $IMPORT_FILE | awk -F '=' '{print $2}')
  1206. if [ ${#TEMP_VALUE} -gt $MINIMUM_LENGTH ]; then
  1207. SSL_CIPHERS=$TEMP_VALUE
  1208. fi
  1209. fi
  1210. if grep -q "SSH_CIPHERS" $IMPORT_FILE; then
  1211. TEMP_VALUE=$(grep "SSH_CIPHERS" $IMPORT_FILE | awk -F '=' '{print $2}')
  1212. if [ ${#TEMP_VALUE} -gt $MINIMUM_LENGTH ]; then
  1213. SSH_CIPHERS=$TEMP_VALUE
  1214. fi
  1215. fi
  1216. if grep -q "SSH_MACS" $IMPORT_FILE; then
  1217. TEMP_VALUE=$(grep "SSH_MACS" $IMPORT_FILE | awk -F '=' '{print $2}')
  1218. if [ ${#TEMP_VALUE} -gt $MINIMUM_LENGTH ]; then
  1219. SSH_MACS=$TEMP_VALUE
  1220. fi
  1221. fi
  1222. if grep -q "SSH_KEX" $IMPORT_FILE; then
  1223. TEMP_VALUE=$(grep "SSH_KEX" $IMPORT_FILE | awk -F '=' '{print $2}')
  1224. if [ ${#TEMP_VALUE} -gt $MINIMUM_LENGTH ]; then
  1225. SSH_KEX=$TEMP_VALUE
  1226. fi
  1227. fi
  1228. if grep -q "SSH_HOST_KEY_ALGORITHMS" $IMPORT_FILE; then
  1229. TEMP_VALUE=$(grep "SSH_HOST_KEY_ALGORITHMS" $IMPORT_FILE | awk -F '=' '{print $2}')
  1230. if [ ${#TEMP_VALUE} -gt $MINIMUM_LENGTH ]; then
  1231. SSH_HOST_KEY_ALGORITHMS=$TEMP_VALUE
  1232. fi
  1233. fi
  1234. if grep -q "SSH_PASSWORDS" $IMPORT_FILE; then
  1235. TEMP_VALUE=$(grep "SSH_PASSWORDS" $IMPORT_FILE | awk -F '=' '{print $2}')
  1236. if [[ $TEMP_VALUE == "yes" || $TEMP_VALUE == "no" ]]; then
  1237. SSH_PASSWORDS=$TEMP_VALUE
  1238. fi
  1239. fi
  1240. if grep -q "XMPP_CIPHERS" $IMPORT_FILE; then
  1241. TEMP_VALUE=$(grep "XMPP_CIPHERS" $IMPORT_FILE | awk -F '=' '{print $2}')
  1242. if [ ${#TEMP_VALUE} -gt $MINIMUM_LENGTH ]; then
  1243. XMPP_CIPHERS=$TEMP_VALUE
  1244. fi
  1245. fi
  1246. if grep -q "XMPP_ECC_CURVE" $IMPORT_FILE; then
  1247. TEMP_VALUE=$(grep "XMPP_ECC_CURVE" $IMPORT_FILE | awk -F '=' '{print $2}')
  1248. if [ ${#TEMP_VALUE} -gt 3 ]; then
  1249. XMPP_ECC_CURVE=$TEMP_VALUE
  1250. fi
  1251. fi
  1252. }
  1253. function export_settings {
  1254. if [ ! $EXPORT_FILE ]; then
  1255. return
  1256. fi
  1257. cd "$CURRENT_DIR" || exit 92465274527
  1258. if [ ! -f $EXPORT_FILE ]; then
  1259. if [ "$SSL_PROTOCOLS" ]; then
  1260. echo "SSL_PROTOCOLS=$SSL_PROTOCOLS" >> $EXPORT_FILE
  1261. fi
  1262. if [ "$SSL_CIPHERS" ]; then
  1263. echo "SSL_CIPHERS=$SSL_CIPHERS" >> $EXPORT_FILE
  1264. fi
  1265. if [ "$SSH_CIPHERS" ]; then
  1266. echo "SSH_CIPHERS=$SSH_CIPHERS" >> $EXPORT_FILE
  1267. fi
  1268. if [ "$SSH_MACS" ]; then
  1269. echo "SSH_MACS=$SSH_MACS" >> $EXPORT_FILE
  1270. fi
  1271. if [ "$SSH_KEX" ]; then
  1272. echo "SSH_KEX=$SSH_KEX" >> $EXPORT_FILE
  1273. fi
  1274. if [ "$SSH_HOST_KEY_ALGORITHMS" ]; then
  1275. echo "SSH_HOST_KEY_ALGORITHMS=$SSH_HOST_KEY_ALGORITHMS" >> $EXPORT_FILE
  1276. fi
  1277. if [ "$SSH_PASSWORDS" ]; then
  1278. echo "SSH_PASSWORDS=$SSH_PASSWORDS" >> $EXPORT_FILE
  1279. fi
  1280. if [ "$XMPP_CIPHERS" ]; then
  1281. echo "XMPP_CIPHERS=$XMPP_CIPHERS" >> $EXPORT_FILE
  1282. fi
  1283. if [ "$XMPP_ECC_CURVE" ]; then
  1284. echo "XMPP_ECC_CURVE=$XMPP_ECC_CURVE" >> $EXPORT_FILE
  1285. fi
  1286. echo "Security settings exported to $EXPORT_FILE"
  1287. exit 0
  1288. fi
  1289. if [ "$SSL_PROTOCOLS" ]; then
  1290. if grep -q "SSL_PROTOCOLS" $EXPORT_FILE; then
  1291. sed -i "s|SSL_PROTOCOLS=.*|SSL_PROTOCOLS=$SSL_PROTOCOLS|g" $EXPORT_FILE
  1292. else
  1293. echo "SSL_PROTOCOLS=$SSL_PROTOCOLS" >> $EXPORT_FILE
  1294. fi
  1295. fi
  1296. if [ "$SSL_CIPHERS" ]; then
  1297. if grep -q "SSL_CIPHERS" $EXPORT_FILE; then
  1298. sed -i "s|SSL_CIPHERS=.*|SSL_CIPHERS=$SSL_CIPHERS|g" $EXPORT_FILE
  1299. else
  1300. echo "SSL_CIPHERS=$SSL_CIPHERS" >> $EXPORT_FILE
  1301. fi
  1302. fi
  1303. if [ "$SSH_CIPHERS" ]; then
  1304. if grep -q "SSH_CIPHERS" $EXPORT_FILE; then
  1305. sed -i "s|SSH_CIPHERS=.*|SSH_CIPHERS=$SSH_CIPHERS|g" $EXPORT_FILE
  1306. else
  1307. echo "SSH_CIPHERS=$SSH_CIPHERS" >> $EXPORT_FILE
  1308. fi
  1309. fi
  1310. if [ "$SSH_MACS" ]; then
  1311. if grep -q "SSH_MACS" $EXPORT_FILE; then
  1312. sed -i "s|SSH_MACS=.*|SSH_MACS=$SSH_MACS|g" $EXPORT_FILE
  1313. else
  1314. echo "SSH_MACS=$SSH_MACS" >> $EXPORT_FILE
  1315. fi
  1316. fi
  1317. if [ "$SSH_KEX" ]; then
  1318. if grep -q "SSH_KEX" $EXPORT_FILE; then
  1319. sed -i "s|SSH_KEX=.*|SSH_KEX=$SSH_KEX|g" $EXPORT_FILE
  1320. else
  1321. echo "SSH_KEX=$SSH_KEX" >> $EXPORT_FILE
  1322. fi
  1323. fi
  1324. if [ "$SSH_HOST_KEY_ALGORITHMS" ]; then
  1325. if grep -q "SSH_HOST_KEY_ALGORITHMS" $EXPORT_FILE; then
  1326. sed -i "s|SSH_HOST_KEY_ALGORITHMS=.*|SSH_HOST_KEY_ALGORITHMS=$SSH_HOST_KEY_ALGORITHMS|g" $EXPORT_FILE
  1327. else
  1328. echo "SSH_HOST_KEY_ALGORITHMS=$SSH_HOST_KEY_ALGORITHMS" >> $EXPORT_FILE
  1329. fi
  1330. fi
  1331. if [ "$SSH_PASSWORDS" ]; then
  1332. if grep -q "SSH_PASSWORDS" $EXPORT_FILE; then
  1333. sed -i "s|SSH_PASSWORDS=.*|SSH_PASSWORDS=$SSH_PASSWORDS|g" $EXPORT_FILE
  1334. else
  1335. echo "SSH_PASSWORDS=$SSH_PASSWORDS" >> $EXPORT_FILE
  1336. fi
  1337. fi
  1338. if [ "$XMPP_CIPHERS" ]; then
  1339. if grep -q "XMPP_CIPHERS" $EXPORT_FILE; then
  1340. sed -i "s|XMPP_CIPHERS=.*|XMPP_CIPHERS=$XMPP_CIPHERS|g" $EXPORT_FILE
  1341. else
  1342. echo "XMPP_CIPHERS=$XMPP_CIPHERS" >> $EXPORT_FILE
  1343. fi
  1344. fi
  1345. if [ "$XMPP_ECC_CURVE" ]; then
  1346. if grep -q "XMPP_ECC_CURVE" $EXPORT_FILE; then
  1347. sed -i "s|XMPP_ECC_CURVE=.*|XMPP_ECC_CURVE=$XMPP_ECC_CURVE|g" $EXPORT_FILE
  1348. else
  1349. echo "XMPP_ECC_CURVE=$XMPP_ECC_CURVE" >> $EXPORT_FILE
  1350. fi
  1351. fi
  1352. echo $"Security settings exported to $EXPORT_FILE"
  1353. exit 0
  1354. }
  1355. function refresh_gpg_keys {
  1356. for d in /home/*/ ; do
  1357. USERNAME=$(echo "$d" | awk -F '/' '{print $3}')
  1358. if [[ $(is_valid_user "$USERNAME") == "1" ]]; then
  1359. su -c 'gpg --refresh-keys' - "$USERNAME"
  1360. fi
  1361. done
  1362. exit 0
  1363. }
  1364. function monkeysphere_sign_server_keys {
  1365. server_keys_file=/home/$USER/.monkeysphere/server_keys
  1366. if [ ! -f "$server_keys_file" ]; then
  1367. exit 0
  1368. fi
  1369. keys_signed=
  1370. while read -r line; do
  1371. echo "$line"
  1372. if [ ${#line} -gt 2 ]; then
  1373. fpr=$(gpg --with-colons --fingerprint "$line" | grep fpr | head -n 1 | awk -F ':' '{print $10}')
  1374. if [ ${#fpr} -gt 2 ]; then
  1375. if gpg --sign-key "$fpr"; then
  1376. gpg --update-trustdb
  1377. keys_signed=1
  1378. fi
  1379. fi
  1380. fi
  1381. done <"$server_keys_file"
  1382. if [ $keys_signed ]; then
  1383. rm "$server_keys_file"
  1384. fi
  1385. exit 0
  1386. }
  1387. function htmly_hash {
  1388. # produces a hash corresponding to a htmly password
  1389. pass="$1"
  1390. HTMLYHASH_FILENAME=/usr/bin/htmlyhash
  1391. { echo '<?php';
  1392. echo "parse_str(implode(\"&\", array_slice(\$argv, 1)), \$_GET);";
  1393. echo "\$password = \$_GET[\"password\"];";
  1394. echo "\$hash = password_hash(\$password, PASSWORD_BCRYPT);";
  1395. echo "if (password_verify(\$password, \$hash)) {";
  1396. echo " echo \$hash;";
  1397. echo '}';
  1398. echo '?>'; } > "$HTMLYHASH_FILENAME"
  1399. php $HTMLYHASH_FILENAME password="$pass"
  1400. }
  1401. function show_help {
  1402. echo ''
  1403. echo "${PROJECT_NAME}-sec"
  1404. echo ''
  1405. echo $'Alters the security settings'
  1406. echo ''
  1407. echo ''
  1408. echo $' -h --help Show help'
  1409. echo $' -e --export Export security settings to a file'
  1410. echo $' -i --import Import security settings from a file'
  1411. echo $' -r --refresh Refresh GPG keys for all users'
  1412. echo $' -s --sign Sign monkeysphere server keys'
  1413. echo $' --register [domain] Register a https domain with monkeysphere'
  1414. echo $' -b --htmlyhash [password] Returns the hash of a password for a htmly blog'
  1415. echo ''
  1416. exit 0
  1417. }
  1418. # Get the commandline options
  1419. while [ $# -gt 1 ]
  1420. do
  1421. key="$1"
  1422. case $key in
  1423. -h|--help)
  1424. show_help
  1425. ;;
  1426. # Export settings
  1427. -e|--export)
  1428. shift
  1429. EXPORT_FILE="$1"
  1430. ;;
  1431. # Export settings
  1432. -i|--import)
  1433. shift
  1434. IMPORT_FILE="$1"
  1435. ;;
  1436. # Refresh GPG keys
  1437. -r|--refresh)
  1438. shift
  1439. refresh_gpg_keys
  1440. ;;
  1441. # register a website
  1442. --register|--reg|--site)
  1443. shift
  1444. register_website "$1"
  1445. ;;
  1446. # user signs monkeysphere server keys
  1447. -s|--sign)
  1448. shift
  1449. monkeysphere_sign_server_keys
  1450. ;;
  1451. # get a hash of the given htmly password
  1452. -b|--htmlyhash)
  1453. shift
  1454. htmly_hash "$1"
  1455. exit 0
  1456. ;;
  1457. *)
  1458. # unknown option
  1459. ;;
  1460. esac
  1461. shift
  1462. done
  1463. menu_security_settings
  1464. exit 0